//
// Copyright (c) 2002-2020 WEINZIERL ENGINEERING GmbH
// All rights reserved.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY DAMAGES OR OTHER LIABILITY,
// WHETHER IN CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE
//

#ifndef __BAOSLIB_IP_GENERAL_H__
#define __BAOSLIB_IP_GENERAL_H__

#include "baos/BaosLib_export.h"

/// @cond DOCUMENT_STL
#include <cstdint>
#include <string>
#include <vector>
/// @endcond

/*!
    @file
    @brief  Provides the structures for devices with IP capabilities
 */

namespace wz::baos::ip
{

//! Represent the pair of IP address as string in the form "10.0.0.1020" and a port
struct Ip4SocketAddress
{
	std::string address;    //!< IPv4 address as string
	std::uint16_t port{0};  //!< The port to use
};


}  // namespace wz::baos::ip

#endif  // __BAOSLIB_IP_GENERAL_H__
