//
// Copyright (c) 2002-2023 WEINZIERL ENGINEERING GmbH
// All rights reserved.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY DAMAGES OR OTHER LIABILITY,
// WHETHER IN CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE
//

#ifndef __BAOSLIB_TCP_DRIVER_H__
#define __BAOSLIB_TCP_DRIVER_H__

#include "baos/config.h"
#include <memory>
#include <string>

namespace wz::baos::ip
{

class BAOSLIB_EXPORT Ip4Driver
{
public:
	using UPtr                                                           = std::unique_ptr<Ip4Driver>;
	Ip4Driver()                                                          = default;
	virtual ~Ip4Driver()                                                 = default;
	virtual void open(const std::string& IP4Address, std::uint16_t port) = 0;
	virtual void close()                                                 = 0;
	virtual std::uint16_t read(Buffer& buf, std::uint16_t offset = 0)    = 0;
	virtual void write(const Buffer& buf)                                = 0;
	virtual bool isOpen()                                                = 0;
};

}  // namespace wz::baos::ip

#endif  // __BAOSLIB_TCP_DRIVER_H__
