//
// Copyright (c) 2002-2023 WEINZIERL ENGINEERING GmbH
// All rights reserved.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY DAMAGES OR OTHER LIABILITY,
// WHETHER IN CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE
//

#ifndef __BAOSLIB_TCP_DRIVER_WIN_H__
#define __BAOSLIB_TCP_DRIVER_WIN_H__

#include "TcpDriver.h"
#include "baos/BaosLib_export.h"
#include "baos/config.h"


#include <memory>
#include <string>
#include <thread>

namespace wz::baos::ip
{

class BAOSLIB_NO_EXPORT Ip4TcpDriver : public Ip4Driver
{
public:
	Ip4TcpDriver();
	~Ip4TcpDriver();
	void open(const std::string& IP4Address, std::uint16_t port) override;
	void close() override;
	std::uint16_t read(Buffer& buf, std::uint16_t offset = 0) override;
	void write(const Buffer& buf) override;
	bool isOpen() override;

private:
	std::int32_t sockfd_{0};
};

}  // namespace wz::baos::ip

#endif  // __BAOSLIB_TCP_DRIVER_WIN_H__
